<?php

function returnStatusCode($statuscode) {
	if ($statuscode) {
		header("HTTP/1.0 " . $statuscode, true);
	} else {
		header("HTTP/1.0 555 Status Code Undefined", true);
	}
	exit(0);
}

function setStatusCode($statuscode) {
	if ($statuscode) {
		header("HTTP/1.0 " . $statuscode, true);
	}
}

function addNewBlogEntry() {
	global $req, $conn, $urlPrefix;
	
	foreach ($req->atomDoc->entries as $entry) {

		// 1. Add author and get new authorid, or retrieve existing authorid
		$authorid = 0;
		$query = "SELECT id FROM atomauthor WHERE name='" . addslashes($entry->author->name) . "' AND url='" . addslashes($entry->author->url) . "' AND email='" . addslashes($entry->author->email) . "'";
		$result = mysql_query($query);
			if (mysql_error()) { print "SQL: $query\nError: " . mysql_error() . "\n\n"; }
		if (mysql_num_rows($result)>0) {
			$line = mysql_fetch_array($result);
			$authorid = $line[0];
		} else {
			$query = $entry->newBlogAuthorAsSql();
			#print "InsertAuthor: " . $query . "\n\n";			
			mysql_query($query);
			if (mysql_error()) { print "SQL: $query\nError: " . mysql_error() . "\n\n"; }
			$authorid = mysql_insert_id();
			#$authorid = 9;
		}

		// 2. Add blog entry and get new entryid
		$query = $entry->newBlogEntryAsSql($authorid);
		#print "InsertBlog: " . $query . "\n\n";
		mysql_query($query);
		if (mysql_error()) { print "SQL: $query\nError: " . mysql_error() . "\n\n"; }
		$entryid = mysql_insert_id();
		#$entryid = 3;
		
		// 3. Add content
		$query = $entry->newBlogContentAsSql($entryid);
		#print "InsertContent: " . $query . "\n\n";
		mysql_query($query);
		if (mysql_error()) { print "SQL: $query\nError: " . mysql_error() . "\n\n"; }
		#print mysql_affected_rows() . ":" . mysql_error() . "\n\n";
		
		// 4. Add/Update contributor
		// [TODO]
		
		// 5. Return a successful status code
		#print $entry->entryAsXml();
	}
	
	if ($entryid) {
		returnStatusCode("201 Created");
	} else {
		returnStatusCode("520 Bogus Resource");
	}
}

function updateBlogEntry() {
	global $req, $conn, $urlPrefix;

	$entryid=0;
	
	$entry = $req->atomDoc->entries[0];
	$query = "SELECT id FROM atomentry WHERE entryid='" . addslashes($entry->id) . "'";
	$result = mysql_query($query);
	
	if (mysql_num_rows($result)>0) {
		$line = mysql_fetch_array($result);
		$entryid = $line[0];
		$entry->entryid = $entryid;
	}

	if ($entryid) {
		// 1. Add author and get new authorid, or retrieve existing authorid
		$authorid = 0;
		$query = "SELECT id FROM atomauthor WHERE name='" . addslashes($entry->author->name) . "' AND url='" . addslashes($entry->author->url) . "' AND email='" . addslashes($entry->author->email) . "'";
		$result = mysql_query($query);
			if (mysql_error()) { print "SQL: $query\nError: " . mysql_error() . "\n\n"; }
		if (mysql_num_rows($result)>0) {
			$line = mysql_fetch_array($result);
			$authorid = $line[0];
		} else {
			$query = $entry->newBlogAuthorAsSql();
			#print "InsertAuthor: " . $query . "\n\n";			
			mysql_query($query);
			if (mysql_error()) { print "SQL: $query\nError: " . mysql_error() . "\n\n"; }
			$authorid = mysql_insert_id();
			#$authorid = 9;
		}

		// 2. Update blog entry
		$query = $entry->updateBlogEntryAsSql($authorid);
		#print "UpdateBlog: " . $query . "\n\n";
		mysql_query($query);
		if (mysql_error()) { print "SQL: $query\nError: " . mysql_error() . "\n\n"; }
		#$entryid = 3;

		// 3. Delete current content and insert new content
		$query = "DELETE FROM atomcontent WHERE entryid=" . $entryid;
		mysql_query($query);
		if (mysql_error()) { print "SQL: $query\nError: " . mysql_error() . "\n\n"; }
		$query = $entry->newBlogContentAsSql($entryid);
		#print "UpdateContent: " . $query . "\n\n";
		mysql_query($query);
		if (mysql_error()) { print "SQL: $query\nError: " . mysql_error() . "\n\n"; }
		#print mysql_affected_rows() . ":" . mysql_error() . "\n\n";

		// 4. Add/Update contributor
		// [TODO]

		returnStatusCode("205 Reset Content");
	} else {
		returnStatusCode("520 Bogus Resource");
	}
}

function deleteBlogEntry() {
	global $req, $conn;

	$entryid = 0;
	$query = "SELECT id FROM atomentry WHERE shortName='" . addslashes($req->blogEntry) . "'";
	#print $query . "\n\n";
	$result = mysql_query($query);
	if (mysql_error()) { print "SQL: $query\nError: " . mysql_error() . "\n\n"; }
	
	if (mysql_num_rows($result)>0) {
		$line = mysql_fetch_array($result);
		$entryid = $line[0];

		// Delete atom content
		$query = "DELETE FROM atomcontent WHERE entryid=" . addslashes($entryid);
		#print $query . "\n\n";
		$result = mysql_query($query);
		if (mysql_error()) { print "SQL: $query\nError: " . mysql_error() . "\n\n"; }

		// Delete atom blog entry		
		$query = "DELETE FROM atomentry WHERE id=" . addslashes($entryid);
		#print $query . "\n\n";
		$result = mysql_query($query);
		if (mysql_error()) { print "SQL: $query\nError: " . mysql_error() . "\n\n"; }

		returnStatusCode("200 Ok");
		print "Content Deleted!";
	} else {
		returnStatusCode("520 Bogus Resource");
		print "Content NOT Deleted!";
	}
}

function getCurrentBlogEntries() {
	global $req, $conn, $urlPrefix;
	
	$entries = array();

	$tpl = new TemplatePower("atomFeed.xml");
	$tpl->prepare();
	$tpl->assign("feedTitle", "PHP AtomAPI implementation");
	$tpl->assign("feedUrl", $urlPrefix ."/". $req->blogName . "/");
	$tpl->assign("feedTagLine","A list entries in this blog");


	$query = "SELECT atomentry.id, title, shortName, link, modified, authorid, entryid, issued, created, summary, blogname, name, url, email FROM atomentry, atomauthor WHERE authorid=atomauthor.id ORDER BY modified DESC LIMIT 0,8";
	$result = mysql_query($query);

	#print $query;

	if (mysql_num_rows($result)>0) {
		while ($line = mysql_fetch_array($result)) {
			$entry = new AtomEntry();
			
			$entry->title     = $line[1];
			$entry->link      = $line[3];
			$entry->shortName = $line[2];
			$entry->modified  = dateSqlToW3Date($line[4]);
			$entry->id        = $line[6];
			$entry->issued    = dateSqlToW3Date($line[7]);
			$entry->created   = dateSqlToW3Date($line[8]);
			$entry->summary   = $line[9];

			$entryid          = $line[0];

			$auth = new AtomAuthor();
			$auth->name  = $line[11];
			$auth->url   = $line[12];
			$auth->email = $line[13];
			$entry->author = $auth;
			
			array_push($entries, $entry);
		}
		
		setStatusCode("200 Ok");
		header ("Content-Type: text/xml");

		$tpl->assign("feedLastModified", $entry->modified);
		foreach($entries as $entry) {
			$tpl->newBlock("entryDetails");
			$tpl->assign("entry", $entry->entryAsXml());
			$tpl->gotoBlock( "_ROOT" );
		}


	}
	$tpl->printToScreen();			
}

function getBlogEntry($blogEntry="") {
	global $req, $conn;
	
	if (!$blogEntry) { $blogEntry = $req->blogEntry; }
	
	$query = "SELECT atomentry.id, title, shortName, link, modified, authorid, entryid, issued, created, summary, blogname, name, url, email FROM atomentry, atomauthor WHERE shortName='" . addslashes($blogEntry) . "' AND authorid=atomauthor.id";
	$result = mysql_query($query);
	
	#print $query;
	if (mysql_num_rows($result)>0) {
		$entry = new AtomEntry();
		$line = mysql_fetch_array($result);
		
		$entry->title     = $line[1];
		$entry->link      = $line[3];
		$entry->shortName = $line[2];
		$entry->modified  = dateSqlToW3Date($line[4]);
		$entry->id        = $line[6];
		$entry->issued    = dateSqlToW3Date($line[7]);
		$entry->created   = dateSqlToW3Date($line[8]);
		$entry->summary   = $line[9];

		$entryid          = $line[0];

		$auth = new AtomAuthor();
		$auth->name  = $line[11];
		$auth->url   = $line[12];
		$auth->email = $line[13];
		$entry->author = $auth;

		$query = "SELECT id, type, mode, text, entryid FROM atomcontent WHERE entryid =" . addslashes($entryid) . "";
		$result = mysql_query($query);
		
		if (mysql_num_rows($result)>0) {
			while($line = mysql_fetch_array($result)) {
				$cont = new AtomContent();
				$cont->type = $line[1];
				$cont->mode = $line[2];
				$cont->text = $line[3];
				
				array_push($entry->content, $cont);
			}

		}
				
		if ($entry) {
			setStatusCode("200 Ok");
			header ("Content-Type: text/xml");
			
			$tpl = new TemplatePower("atomEntry.xml");
			$tpl->prepare();
			
			$tpl->assign("entry", $entry->entryAsXml());
			
			$tpl->printToScreen();			
		} else {
			returnStatusCode("404 Not Found");
		}

	}
	
}


/**************************************
 *
 * Date conversion routines
 *
 **************************************/
 
// W3Date:        2003-07-22T07:11-05:00
// SQL Timestamp: 20030722071100
 
function dateW3DateToSql($w3Date) {
	if ($w3Date) {
		preg_match("/^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2})-(\d{2}):(\d{2})$/", $w3Date, $bits);
		#print "["; foreach($bits as $bit) { print $bit . "|"; };
		return $bits[1] . $bits[2] . $bits[3] . $bits[4] . $bits[5] . "00";
	}
}

function dateSqlToW3Date($sqlDate) {
	if($sqlDate) {
		preg_match("/^(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})$/", $sqlDate, $bits);
		#print "["; foreach($bits as $bit) { print $bit . "|"; };
		return $bits[1] ."-". $bits[2] ."-". $bits[3] ."T". $bits[4] .":". $bits[5] ."+01:00";		
	}
}
 
?>